require 'nuge/clients/grocer'

describe Nuge::Clients::Grocer do
  describe '#initialize' do
    it 'passes initialization options directly to the service class' do
      client = Nuge::Clients::Grocer.new(certificate: '/path/to/cert.pem')

      expect(::Grocer).to receive(:pusher).with(certificate: '/path/to/cert.pem')

      client.pusher
    end
  end

  describe '#push' do
    it 'forwards formatted payloads through the service' do
      client = Nuge::Clients::Grocer.new(certificate: '/path/to/cert.pem')

      expect(client.pusher).to receive(:push).twice

      client.push(['1234', '5678'], alert: 'Hello!')
    end
  end
end

